/*
From mjp@hplb.hpl.hp.com Fri Mar 25 17:41:33 1994
To: sy-list@chorus.fr
Subject: A little program-ette
Content-Length: 1592
X-Lines: 88

Hi All,

I've just got around to grabbing the DX7 sounds kindly collated by
Herbert Janssen, and decided I really wanted a catalog file of what
patches are in each bank.  Here's a little hacked program to do the
job.  Just cut'n'paste the code, compile it, and then run it with
something like:

	./names dx7-01.j01

and it'll print out the list of names for each of the 64 patches in
the named bank.

This program was compiled on HP-UX v9.0 on an HP s700 series machine.
Hopefully it'll compile on anything else.

Share ane enjoy!  

Cheers,

Mike

mjp@hplb.hpl.hp.com                   "Only those who attempt the absurd will 
                                                     achieve the impossible."


---------Snippety-snip-----------------------------------------------------
*/

/* names.c */

#include <stdio.h>

#define HDR_JUNK 0x3D0

#define PSIZE 0x2D0
#define SIZEBANKD 0x560

#define HDR	0x2001
#define NLEN 10

#define NUMPATCHES	48
#define NUMBANKD        16

main(argc, argv)
     int argc; 
     char *argv[];
{
  FILE *fp;
  int i;
  
  if ((fp = fopen(argv[1], "r")) == NULL)
  {
    printf("Can't open file %s\n", argv[1]);
    exit 1 ;
  }
  
  fseek(fp, HDR, SEEK_CUR);
  
  for (i=1; i<NUMPATCHES; i++)
    printName(fp, i, PSIZE);
  
  fseek(fp, HDR_JUNK, SEEK_CUR);
  
  for (i=1; i<(NUMBANKD+1); i++)
    printName(fp, i+NUMPATCHES, SIZEBANKD);
  
  fclose(fp);
}


int 
printName(fp, i, sz)
FILE *fp;
int i;
int sz;
{
  char pname[NLEN+1];
  
  fgets(pname, sizeof(pname), fp);
  printf("%2d : %s\n", i, pname);
  fseek(fp, sz-NLEN, SEEK_CUR);
  
  return 1;
}






